-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.0.24-community-nt


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema test
--

CREATE DATABASE IF NOT EXISTS test;
USE test;

--
-- Definition of table `course`
--

DROP TABLE IF EXISTS `course`;
CREATE TABLE `course` (
  `courseID` varchar(7) NOT NULL,
  `name` varchar(45) default NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`courseID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `course`
--

/*!40000 ALTER TABLE `course` DISABLE KEYS */;
INSERT INTO `course` (`courseID`,`name`,`description`) VALUES 
 ('tdt4210',NULL,NULL);
/*!40000 ALTER TABLE `course` ENABLE KEYS */;


--
-- Definition of table `lecture`
--

DROP TABLE IF EXISTS `lecture`;
CREATE TABLE `lecture` (
  `lectureid` int(10) unsigned NOT NULL auto_increment,
  `course` varchar(7) NOT NULL,
  `description` varchar(45) default NULL,
  PRIMARY KEY  (`lectureid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `lecture`
--

/*!40000 ALTER TABLE `lecture` DISABLE KEYS */;
INSERT INTO `lecture` (`lectureid`,`course`,`description`) VALUES 
 (1,'tdt4210',NULL);
/*!40000 ALTER TABLE `lecture` ENABLE KEYS */;


--
-- Definition of table `player`
--

DROP TABLE IF EXISTS `player`;
CREATE TABLE `player` (
  `username` varchar(20) NOT NULL,
  `password` varchar(20) NOT NULL,
  `registrationdate` datetime NOT NULL,
  `deprecated` int(10) unsigned NOT NULL,
  `isAdmin` tinyint(1) NOT NULL,
  PRIMARY KEY  (`username`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `player`
--

/*!40000 ALTER TABLE `player` DISABLE KEYS */;
INSERT INTO `player` (`username`,`password`,`registrationdate`,`deprecated`,`isAdmin`) VALUES 
 ('a','a','0000-00-00 00:00:00',0,1),
 ('Terje','sesam','0000-00-00 00:00:00',0,1);
/*!40000 ALTER TABLE `player` ENABLE KEYS */;


--
-- Definition of table `question`
--

DROP TABLE IF EXISTS `question`;
CREATE TABLE `question` (
  `questionID` int(10) unsigned NOT NULL auto_increment,
  `question` text NOT NULL,
  `roundid` int(10) unsigned default NULL,
  `timelimit` int(10) unsigned default NULL,
  PRIMARY KEY  (`questionID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `question`
--

/*!40000 ALTER TABLE `question` DISABLE KEYS */;
INSERT INTO `question` (`questionID`,`question`,`roundid`,`timelimit`) VALUES 
 (1,'What is your name?',1,30),
 (2,'What decide sw architecture?',1,30);
/*!40000 ALTER TABLE `question` ENABLE KEYS */;


--
-- Definition of table `question_alternative`
--

DROP TABLE IF EXISTS `question_alternative`;
CREATE TABLE `question_alternative` (
  `alternativeID` int(10) unsigned NOT NULL auto_increment,
  `questionid` varchar(45) NOT NULL,
  `alternative` varchar(80) NOT NULL,
  `isCorrectAlt` tinyint(1) NOT NULL,
  PRIMARY KEY  (`alternativeID`,`questionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `question_alternative`
--

/*!40000 ALTER TABLE `question_alternative` DISABLE KEYS */;
INSERT INTO `question_alternative` (`alternativeID`,`questionid`,`alternative`,`isCorrectAlt`) VALUES 
 (1,'1','No name',0),
 (1,'2','Software quality',1),
 (1,'3','After requirement specification',1),
 (2,'1','You have a name',1),
 (2,'2','software function',0),
 (2,'3','The first phase',0),
 (3,'1','Pupy',0),
 (3,'2','sw company',0),
 (3,'3','In the Design phase',0),
 (4,'1','Catty',0),
 (4,'2','sw designer',0),
 (4,'3','When deployment',0);
/*!40000 ALTER TABLE `question_alternative` ENABLE KEYS */;


--
-- Definition of table `round`
--

DROP TABLE IF EXISTS `round`;
CREATE TABLE `round` (
  `roundid` int(10) unsigned NOT NULL auto_increment,
  `lectureID` varchar(45) NOT NULL,
  `gametype` int(10) unsigned NOT NULL COMMENT '10 for measure up, 11 for elimination mode',
  `lecture` int(10) unsigned default NULL,
  PRIMARY KEY  (`roundid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `round`
--

/*!40000 ALTER TABLE `round` DISABLE KEYS */;
INSERT INTO `round` (`roundid`,`lectureID`,`gametype`,`lecture`) VALUES 
 (1,'1',10,1);
/*!40000 ALTER TABLE `round` ENABLE KEYS */;




/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
