package GameEngine.Core;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import GameEngine.GameMode.MeasureUpMode;

/**
 * Extend the GameCommunicator to handle the communication between the GE and master client
 * is responsible to receive message from master client
 * @author tranlongtien
 *
 */
public class MasterCommunicator extends GameCommunicator {


	/**
	 * Constructor
	 * @throws IOException 
	 */
	public MasterCommunicator(Socket socket, Game game) throws IOException{
		super(socket, game);
	}

	/** 
	 * Override the parrent method
	 * The receiver thread run to response to request from master client
	 * Will be called (run forever )until return false
	 */
	public boolean onReceive(){
		
		try {
			// receive message
			strMessageIn = in.readLine();
			System.out.println("From master client: " + strMessageIn);			
		} catch (Exception e) {
			System.out.println("Err of getting request from MasCli: !" + e.getMessage());
			e.printStackTrace();
			// Kill game here!				
			myGame.killGame();
			return false;
		}				
		try{
			msg= new Message(strMessageIn);
			// response to request
			myGame.processMasterMessage(msg);			
		}
		catch (Exception e) {}
		return true;
	}// end onReceive

}// end class
