package Masterclient.Graphics;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsEnvironment;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Enumeration;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.Timer;

import sun.security.krb5.Asn1Exception;

import Masterclient.core.Game;
import Masterclient.core.LG;
import Masterclient.core.Message;
import Masterclient.core.Question;
import Masterclient.core.Respondent;

import com.sun.corba.se.impl.oa.poa.ActiveObjectMap.Key;
import com.sun.corba.se.impl.orbutil.closure.Constant;
import com.sun.org.apache.xalan.internal.xsltc.dom.AbsoluteIterator;
import com.sun.xml.internal.messaging.saaj.packaging.mime.util.QEncoderStream;


public class GameBoard extends JFrame  {

	_KeyListener keysListener; // listener for keys event
	QuestionPanel quesGraphic; // this is the panel that will display question
	JPanel gameDisplay; // this is the panel to display answers, roundresult and game result, ...
	Game myGame; // reference to current game
	
	Color[] barColor;

	public GameBoard(Game g) {
		// TODO Auto-generated constructor stub 
		super();		
		myGame =g;
		// init variable
		keysListener  = new _KeyListener();
		//this.addKeyListener(keysListener);
		// graphic object to display question
		quesGraphic = new QuestionPanel();
		// graphic object to display answer, round result and game resutl
		gameDisplay = new JPanel();
		gameDisplay.setBackground(Color.BLACK);
		gameDisplay.addKeyListener(keysListener);
		//gameDisplay.setLayout(null);


		barColor = new Color[]{Color.YELLOW,Color.BLUE,Color.CYAN, Color.GREEN, Color.RED, Color.PINK};

		//init the game board frame to full screeen mode with Black back ground ...
		initGameBoard();

		this.setVisible(true);
	}

	private void initGameBoard(){
		try{
			// Remove boder and decoration buttons, set full screen mode
			this.setUndecorated(true);	
			//this.setSize(600,400);
			GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().setFullScreenWindow(this);			
			// Layout manager			
		}
		catch(Exception e){
		}
	}

	/**
	 * Display a question on screen
	 * @param q
	 */
	public void displayQuestion(Question q){
		this.getContentPane().removeAll();
		this.getContentPane().add(quesGraphic);		

		validate();
		quesGraphic.displayQuestion(q);
	}

	@Override
	public void paintComponents(Graphics arg0) {
		// TODO Auto-generated method stub
		super.paintComponents(arg0);
	}

	/**
	 * Display an anwer depend on the game mode 
	 * @param ans
	 */
	public void displayAnswer(Question q, Respondent answers[] ){
		// prepare the screen for displaying answers
		this.getContentPane().removeAll();
		this.getContentPane().add(gameDisplay);
		repaint();
		validate();
		Graphics g = gameDisplay.getGraphics();		
		Font f = new Font("Sanserif", Font.PLAIN,25);
		g.setFont(f);
		g.setColor(Color.WHITE);
		// Start rendering!
		displayAnswers(q,answers, g, gameDisplay);
		gameDisplay.setFocusable(true);
		gameDisplay.requestFocus();
		gameDisplay.requestFocusInWindow();
	}

	private void displayAnswers(Question q, Respondent anwers[], Graphics g, JPanel display){
		Graphics2D g2 = (Graphics2D)g;
		int height = display.getHeight();
		int wi = display.getWidth();
		int numBar = q.getNumberOfAlt(); // number of bar, each bar is an alternative				
		int margin = wi/6;
		int barWidth = (wi-3*margin/2)/(2*numBar-1);
		int[] barHeight = new int[numBar]; // Be filled later
		int maxHeight = height/2; // maximum height of a bar (100%)
		//	Caculate the bottom left corner
		int yCorBotLef = 2*height/3;
		int[] xCorBotLef = new int[numBar];
		for (int i=0; i<numBar; i++){
			xCorBotLef[i]= margin + 2*i * barWidth;
		}

		// Caculate how many % that each alternative contribute
		double[] results = new double[numBar];
		System.out.println("initFeedback respondents: " +anwers.length );
		for(int i=0;i<anwers.length;i++){
			if(!(anwers[i]==null)) {
				if(anwers[i].getPoints()!=(-1)){
					results[anwers[i].getPoints()] += ((double)1/anwers.length)*100;
					//System.out.println("Alt " + anwers[i].getPoints() + " " + ((double)1/anwers.length)*100 + "%" );
					//System.out.println(anwers[i].getName() + " points " + anwers[i].getPoints());
				}
			}
		}// end for

		// The hight of each bar
		for (int i=0; i<numBar; i++){
			barHeight[i]=(int) (maxHeight * results[i]/100);			
		}

		// the y corodinator of top left corner
		int[] yCorTopLeft = new int[numBar];
		for (int i=0; i<numBar; i++){
			yCorTopLeft[i]= yCorBotLef - barHeight[i];
		}

		// Sleep a while so that the bar can be displayed (??? dont know why it needs this!)
		try {
			Thread.sleep(10);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// Create a small font and a big font
		Font smallFont = new Font("Sanserif", Font.PLAIN,15);
		Font bigFont = new Font("Sanserif", Font.PLAIN,25);
		g.setColor( Color.DARK_GRAY);		
		// draw some line and axis
		int lineMargin = margin/2;
		g.drawLine(lineMargin, yCorBotLef, wi, yCorBotLef);
		g.drawLine(lineMargin, yCorBotLef - maxHeight/2, wi, yCorBotLef -maxHeight/2);
		g.drawString("50%", lineMargin, yCorBotLef - maxHeight/2);
		g.drawLine(lineMargin, yCorBotLef - maxHeight, wi, yCorBotLef -maxHeight);
		g.drawString("100%", lineMargin, yCorBotLef - maxHeight);

		int correctIndex=-1;
		//  Draw the bar and text
		for (int i=0; i<numBar; i++){ 
			// Draw the % of each alternative
			g.setFont(smallFont);
			g.setColor(Color.LIGHT_GRAY);
			g.drawString(results[i] + "%", xCorBotLef[i]+ barWidth/2, yCorTopLeft[i] -20);
			//Draw the bar
			if (i== q.getCorrectAlternative()){ // Correct alternative!
				g.setColor(Color.LIGHT_GRAY);
				correctIndex= i;
				g2.fill3DRect(xCorBotLef[i], yCorTopLeft[i],barWidth, barHeight[i],true );
				//g.setColor(Color.BLACK);
				//g2.fillRect(xCorBotLef[i], yCorTopLeft[i],barWidth, barHeight[i]);
			} else{
				g.setColor(Color.GRAY);
				g2.fill3DRect(xCorBotLef[i], yCorTopLeft[i],barWidth, barHeight[i],false );
			}


			// Draw all the alternatives string
			if (i== q.getCorrectAlternative())
				g.setFont(bigFont);
			else
				g.setFont(smallFont);
			g.setColor(Color.WHITE);
			g.drawString(q.getAlternatives()[i], xCorBotLef[i], yCorBotLef + 30);
		}	
		////
		CorrectAltRender trueAns = new CorrectAltRender();
		trueAns.startAltRender(g,xCorBotLef[correctIndex], yCorTopLeft[correctIndex],barWidth, barHeight[correctIndex]);
	}//

	//////////////////////////////////////////////////////////////////////////////////
	/**
	 * this class is an animation to wink the bar of the correct alternative
	 * @author tranlongtien
	 *
	 */
	private class CorrectAltRender implements ActionListener{
		private Graphics g;
		private int x,y, w,h; // top left and width, height of the bar
		Timer timer; // Swing timer
		boolean draw = false; // start by clear the bar
		int count =0, maxCount = LG.UI_NUMBER_WINKING; // wink 6 times		
		public void startAltRender(Graphics _g, int _x, int _y, int _w, int _h){
			g = _g; x = _x; y =_y; h = _h; w = _w;
			timer = new Timer(LG.UI_DELAY_WINKING, this); // wink every 300 milli seconds (0.3 s)
			timer.start();
		}// 
		public void actionPerformed(ActionEvent arg0) {
			// TODO Auto-generated method stub
			if (draw){
				g.setColor(Color.LIGHT_GRAY);
				g.fill3DRect(x, y, w, h,true);
				draw =false;
			}else{
				draw = true;
				g.setColor(Color.BLACK);
				g.fillRect(x,	y,	 w, h);

			}
			count ++;
			if (count >=maxCount)
				timer.stop();
		}//

	}// end class
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * Exit when press Esc button
	 */
	private class _KeyListener implements KeyListener{

		public void keyPressed(KeyEvent e) {
			// TODO Auto-generated method stub
			if (e.getKeyChar() ==KeyEvent.VK_ESCAPE)
			{
				System.exit(0);
			} else if (e.getKeyChar() == KeyEvent.VK_SPACE)
			{
				if (myGame.getStateOfScn() == LG.SCREEN_STATE_LOGIN_IDLE){
					myGame.setStateOfScn(LG.SCREEN_STATE_ROUND_INTRO);
				
				} else if (myGame.getStateOfScn() == LG.SCREEN_STATE_ROUND_INTRO){
					myGame.startGame();
				} else if (myGame.getStateOfScn() == LG.SCREEN_STATE_DISPLAY_ANSWER){
					myGame.getMaster().send("" + Message.MSG_NEXT_QUESTION);
				}
			} else if (e.getKeyChar()== KeyEvent.VK_R){
				myGame.setStateOfScn(LG.SCREEN_STATE_ROUND_INTRO);
			}
		}

		public void keyReleased(KeyEvent arg0) {
			// TODO Auto-generated method stub

		}

		public void keyTyped(KeyEvent arg0) {
			// TODO Auto-generated method stub

		}

	}// End _KeyListener class

	////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Display end of round depend on the game mode 
	 * @param 
	 */
	
	public void displayEndOfRound(Respondent ansArray[]){
		// prepare the screen for displaying 
		this.getContentPane().removeAll();
		this.getContentPane().add(gameDisplay);

		//repaint();
		validate();
		Graphics g = gameDisplay.getGraphics();
		this.setBackground(Color.BLACK);		
		Arrays.sort(ansArray);				
		Font f = new Font("Sanserif", Font.PLAIN,25);
		g.setFont(f);
		g.setColor(Color.WHITE);
		int y = getHeight()/5;
		g.drawString("The winner of Today: ", 30, y);
		int i =0;
		while(ansArray.length >i && i <3){
			if (ansArray.length >0)
				g.drawString("" + (i+1) + ". " + ansArray[i].getName() + "  with score of " + ansArray[i].getPoints(), 50, y + 30*(i+1));
			i++;
		}
		//myGame.setStateOfScn(LG.SCREEN_STATE_END_ROUND);
		gameDisplay.setFocusable(true);
		gameDisplay.requestFocus();
	}

	/**
	 * Display end of game depend on the game mode 
	 * @param ans
	 */
	public void displayEndOfGame(String ans){
		this.getContentPane().removeAll();
		this.getContentPane().add(gameDisplay);
		//repaint();
		validate();
		Graphics g = gameDisplay.getGraphics();
		this.setBackground(Color.BLACK);
		//Graphics g = this.getGraphics();
		Font f = new Font("Sanserif", Font.PLAIN,25);
		g.setFont(f);
		g.setColor(Color.WHITE);
		g.drawString("RENDER END OF GAME HERE! ", 300, 300);
	}

	/*
	 * Render to screen a logo and the welcome messages as people log in.
	 */
	
	@Override
	public void paint(Graphics arg0) {
		// TODO Auto-generated method stub
		System.out.println("in paint function!");
		super.paint(arg0);
		switch (myGame.getStateOfScn()) {
		case LG.SCREEN_STATE_LOGIN_IDLE:
			displayLoginIdle(myGame.getGameID());
			break;
		case LG.SCREEN_STATE_ROUND_INTRO:
			displayRoundIntro();
			break;
		case LG.SCREEN_STATE_END_ROUND:
			displayEndOfRound(myGame.getAnswerArray());
			break;
		//case LG.SCREEN_STATE_DISPLAY_ANSWER:
			//displayAnswer(myGame.getCurrentQuesiton(), myGame.getAnswerArray());
			//break;
		default:
			break;
		}
	}
	
	public void displayLoginIdle(int gameID){
		this.getContentPane().removeAll();
		this.getContentPane().add(gameDisplay);
		Graphics g = gameDisplay.getGraphics();
		//myGame.setStateOfScn(LG.SCREEN_STATE_LOGIN_IDLE);
		//repaint();
		validate();
		gameDisplay.setFocusable(true);
		gameDisplay.requestFocusInWindow();
		try {
			Thread.sleep(80);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// display the logo at (x,y) within a rectangle, the logo is from a file
		int w= gameDisplay.getWidth()/2;
		int h = 3*w/4;
		int x = gameDisplay.getWidth()/2 - w/2;
		int y = gameDisplay.getHeight()/2 - h/2;
		
		g = gameDisplay.getGraphics();
		g.setColor(Color.RED);
		Font f = new Font("Sanserif", Font.PLAIN,h/15);
		g.setFont(f);
		g.drawString("Today Lechture Code: " + gameID,x+ 100,y + h + 30 );	
		g.setColor(Color.GRAY);
		
		f = new Font("Sanserif", Font.PLAIN,h/20);
		g.setFont(f);
		int i=0, y1 = 40 +h/15,x1=30;
		g.drawString("Number of users logged in: " + myGame.getUserLogin().size(),x1,y1);
		for(Respondent r: myGame.getUserLogin()){
			g.drawString(r.getName(), x1 +10, y1+ (i+1)* h/15);
			i++;
		}
		
		//LoadImage.displayPicture(x, y,w ,h, "C:/_NTNU/Spring 2008/cdrom/source_code/MasterClient/resources/lecturegame.JPG", gameDisplay.getGraphics());
		LoadImage.displayPicture(x, y,w ,h, "lecturegame.JPG", gameDisplay.getGraphics());

	}//
	
	/*
	 * Render to screen a the introduction of the round
	 */	
	public void displayRoundIntro(){
		JTextArea intrTxtArea = new JTextArea();
		intrTxtArea.setBackground(Color.BLACK);
		this.getContentPane().removeAll();
		this.getContentPane().add(intrTxtArea);		
		//repaint();
		validate();		
		intrTxtArea.setFocusable(true);
		intrTxtArea.requestFocusInWindow();		
		int h = getHeight();
		int w = getWidth();
		Insets ins = new Insets(h/4, w/6, h/5, w/8);
		intrTxtArea.setMargin(ins);		
		intrTxtArea.setLineWrap(true);
		Font f = new Font("Sanserif", Font.PLAIN,h/25);
		intrTxtArea.setFont(f);
		intrTxtArea.setForeground(Color.WHITE);
		
		String desc = "It's every man for himself, now. Compete against your classmates by answering before the time is up. Slow and fast answers are equally rewarded. Here we go!! ";
		intrTxtArea.setText(desc);				
		
		intrTxtArea.addKeyListener(keysListener);
		//myGame.setStateOfScn(LG.SCREEN_STATE_ROUND_INTRO);
		SoPlayer.playSound("resources/smas-smb3_goal.wav");
	}//
	
	/**
	 * Render the high score list to screen
	 * 
	 * @param glDrawable
	 * @return
	 */
	public void displayEndGame(){

	}//
	
	
	
}// End class
