package Masterclient.core;

import java.io.*;
import java.net.*;

public class MessagesExchangeThread implements Runnable {

	/**
	 * @uml.property  name="in"
	 */
	private BufferedReader in;
	private PrintWriter out;
	private Socket socket;
	private Configuration myConf = new Configuration();

	private Game myGame; // pointer to the game

	private String messageStr; // message received from game engine

	protected int protocolState;
	
	protected Message msg;

	public MessagesExchangeThread(Game game){
		myGame= game;
		try {
			socket = new Socket(myConf.getServerIP(),myConf.getPort());
			out = new PrintWriter(socket.getOutputStream());
			in = new BufferedReader(new InputStreamReader (socket.getInputStream()));
		}
		catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("Error to connect to server!");
			try {
				socket.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				//e1.printStackTrace();
			}
			System.exit(1);
		}				
		//protocolState = Constantsxxx.PROT_ENDED_STEP2;
	}

	/**
	 * This thread will run in the life of game to receive messages from Game engine
	 * After message arrive call function of game to update state and process message.
	 */
	public void run() {
		// TODO Auto-generated method stub		
		while(true)
		{
			// get message
			try {
				System.err.println("Try to receive msg!");
				messageStr = receiveStr();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				try {
					socket.close();
				} catch (IOException e2) {
					// TODO Auto-generated catch block
					//e2.printStackTrace();
				}
				return; //
			}	
			
			//process message 			
			msg = new Message(messageStr);
			myGame.onReceive(msg);			
/*			long sampleRate = 20;
			try {
				// sleep a while, no need to read all the time
				Thread.sleep(sampleRate);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}*/
		}

	}//end run()


	/**
	 * Strips off protocol specific headers from  the inputStream and returns the remaining String.
	 * Incoming data not following protocol is results in the return of the value null.
	 * 
	 * @return
	 */
/*	public String receive() {
		String rec = "";
		try {
			rec = in.readLine();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			System.out.println ("Error getting message!");
		}
		return rec;
		int ch = 0;
		char[] tempChar = new char[1];
		while (ch != -1) {
			try {
				ch = in.read();
				System.err.print((char)ch);
				tempChar[0] = (char) ch;
				String tempString = new String(tempChar);
				rec = rec + "" + new String(tempChar);
				if ((protocolState == Constantsxxx.PROT_ENDED_STEP2)) {
					if (tempString.equals("@")) {
						protocolState = Constantsxxx.PROT_STARTED_STEP1;
					} else {
						rec = "";
						break;
					}
				} else if ((protocolState == Constantsxxx.PROT_STARTED_STEP1)) {
					if (tempString.equals("^")) {
						protocolState = Constantsxxx.PROT_STARTED_STEP2;
					} else {
						rec = "";
						break;
					}
				} else if (protocolState == Constantsxxx.PROT_STARTED_STEP2) {
					if (tempString.equals("^")) {
						protocolState = Constantsxxx.PROT_ENDED_STEP1;
					}
				} else if ((protocolState == Constantsxxx.PROT_ENDED_STEP1)) {
					if (tempString.equals("@")) {
						protocolState = Constantsxxx.PROT_ENDED_STEP2;
						break;
					} else {
						protocolState = Constantsxxx.PROT_STARTED_STEP2;
					}
				}


			} catch (IOException e) {
				e.printStackTrace();
				ch = -1;
			}

		}
		if (rec.length() > 3) {
			return rec.substring(2, (rec.length() - 2));
		}
		return null;
	}*/

	/***
	 * Sends the given String to the server.
	 * 
	 * @param str
	 */
	public void send(String str) {
		out.println(str);
		out.flush();
		System.err.println("sent to GE: " + str);
	}

	/**
	 * receive a string from game engine
	 * @return
	 * @throws IOException 
	 */
	public String receiveStr() throws IOException
	{
		return in.readLine();
	} // end receiveStr
}// end class
