import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.lcdui.*;

import com.sun.j2mews.xml.rpc.Encoder;

/**
 *
 * Custom grahpical canvas
 *
 *
 * Created by IntelliJ IDEA.
 * User: ofsdahl
 * Date: 23.feb.2007
 * Time: 14:34:33
 * chaged by Tien, 26 April 2008
 * To change this template use File | Settings | File Templates.
 */
public class LeGaGameCanvas extends GameCanvas implements Runnable{


	String[] drawStringList;
	private int screenState;
	private int nextFreeStringIndex;
	private String currentQuestion;
	private String[] currentAlternatives;
	private CommandListener cmdL;
	private boolean answerSent = false;
	private long resultTimer = 0;
	private boolean timesUp = false;

	private boolean currentAnswerWasCorrect;
	private String currentScore;
	private String currentMaxScore;
	private String lastResults = "";
	// private MessagesExchangeThread clientNetwork; ?? why need this, tientl???
	protected Image topBarLine;
	protected Image middleBarLine;
	protected int scoreCounter = 0;
	protected boolean readyToClose = false;

	/**
	 *
	 * Load pictures
	 *
	 * @param b  supress keystrokes
	 */
	protected LeGaGameCanvas(boolean b) {
		super(false);
		drawStringList = new String[6];
		screenState = -1;
		nextFreeStringIndex = 0;
		try{
			topBarLine = Image.createImage("/barthin.png");
			middleBarLine = Image.createImage("/middlebar.png");
		} catch(Exception e){
			e.printStackTrace();
		}
		this.setFullScreenMode(true);
	}

	/**
	 * Set the apporpriate commandlistener interface class.
	 * @param cmdL
	 */
	public void setCommandListener(CommandListener cmdL){
		super.setCommandListener(cmdL);
		this.cmdL = cmdL;

	}

	/**
	 *
	 * Set the alterniatives to be displayed
	 *
	 * @param alternatives
	 */
	public void setCurrentAlternatives(String[] alternatives){
		this.currentAlternatives = alternatives;
	}

	/**
	 * Set the question to be displayed
	 *
	 * @param string
	 */
	public void setCurrentQuestion(String string){
		answerSent = false;
		currentQuestion = string;
	}


	/**
	 * The forever running gaphical rendering thread runs here.
	 *
	 */
	public void run() {
		while(true){
			updateGameScreen(getGraphics());
			try {
				Thread.currentThread().sleep(30);
			} catch(Exception e) {}
		}
	}


	/**
	 *
	 * Routs the graphical processing to the appropriate methods according to
	 * the current state of the program.
	 *
	 *
	 * @param g grahpics object for rendering.
	 */
	private void updateGameScreen(Graphics g){
		g.setColor(0xc2e2ff);
		g.fillRect(0, 0, getWidth(), getHeight());
		int xCounter = 0;
		while(xCounter<((getWidth()/2))-40){
			g.drawImage (topBarLine, xCounter, 0, Graphics.TOP | Graphics.LEFT);
			xCounter +=1;
		}
		g.drawImage (middleBarLine, xCounter, 0, Graphics.TOP | Graphics.LEFT);
		xCounter+= middleBarLine.getWidth();
		while(xCounter<(getWidth())){
			g.drawImage (topBarLine, xCounter, 0, Graphics.TOP | Graphics.LEFT);
			xCounter +=1;
		}

		try {
			if(screenState == Constants.SCREENSTATE_IDLE){
				drawIdleScreen(g);
			} else if(screenState == Constants.SCREENSTATE_QUESTION_POPPER){
				drawQuestion(g);
			} else if(screenState == Constants.SCREENSTATE_RESULTS){
				drawResults(g);
			} else if(screenState == Constants.SCREENSTATE_ENDGAME){
				drawEndResults(g);
			}
			// this call paints off screen buffer to screen
			flushGraphics();
		} catch(Exception e){
			e.printStackTrace();
		}
	}


	/**
	 *
	 * Draws the idle screen.
	 *
	 * @param g
	 */
	private void drawIdleScreen(Graphics g){
		timesUp = false;
		g.setColor(0x00008b);
		g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
		g.drawString("Hold on, stay sharp!",5,0+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
		flushGraphics();
	}

	/**
	 * Draws the en result when the game is about to finish.
	 *
	 * @param g
	 */
	private void drawEndResults(Graphics g) {
		g.setColor(0x00008b);
		g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
		if(scoreCounter<Integer.parseInt(lastResults)){
			scoreCounter++;
		}
		if((System.currentTimeMillis()%1500)<700){
			g.drawString("GAME OVER!",5,0+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
		}

		g.drawString("Your score : "  + scoreCounter ,5,0+ Constants.SCREEN_OFFSET*2,Graphics.TOP|Graphics.LEFT);
		g.drawString("of " + currentMaxScore + " possible points" ,5,0+ Constants.SCREEN_OFFSET*3,Graphics.TOP|Graphics.LEFT);

		if(readyToClose){
			g.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
			g.setColor(0xff0000);
			if((System.currentTimeMillis()%600)<200)
				g.drawString("/ Press any key to close /",30,Constants.SCREEN_OFFSET*5,Graphics.BOTTOM|Graphics.LEFT);
			else  if((System.currentTimeMillis()%600)<400)
				g.drawString("- Press any key to close -",30,Constants.SCREEN_OFFSET*5,Graphics.BOTTOM|Graphics.LEFT);
			else
				g.drawString("\\ Press any key to close \\",30,Constants.SCREEN_OFFSET*5,Graphics.BOTTOM|Graphics.LEFT);
		}
		flushGraphics();
	}


	/**
	 *
	 * Draws a quesiton and the appropriate alternatives.
	 *
	 * @param g
	 */
	public void drawQuestion(Graphics g){
		int cut=0;
		int charPerLine =28;
		int offsetCounter =  (g.getFont().getHeight())*1;
		g.setColor(0x000000);
		//int MaxLengthOfLine = (getWidth()/offsetCounter)*1;
		//System.out.println("max__:"+ MaxLengthOfLine);
		String currentRealQuestion = currentQuestion;

		while(currentRealQuestion.length()>charPerLine){
			/*cut = currentRealQuestion.substring(0,25).lastIndexOf((32));
			g.drawString(currentRealQuestion.substring(0,cut),5,offsetCounter + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);

			currentRealQuestion = currentRealQuestion.substring(cut+1,currentRealQuestion.length());
			offsetCounter+= (g.getFont().getHeight());
*/	
			char endChar;
			int nexpos;
			if (currentRealQuestion.charAt(charPerLine) == 32){
				cut =charPerLine;
				nexpos =cut +1;
				endChar =32;
			} else {
				cut =charPerLine-1;
 				if (currentRealQuestion.charAt(charPerLine-1) ==32){				
				 nexpos = cut+1;
				 endChar = 32;
				}else {					
					nexpos =cut;
					endChar = '-';
				}
			}			
			g.drawString(currentRealQuestion.substring(0,cut) + endChar,5,offsetCounter + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
			currentRealQuestion = currentRealQuestion.substring(nexpos,currentRealQuestion.length());
			offsetCounter+= (g.getFont().getHeight());
		}
		g.drawString(currentRealQuestion,5,offsetCounter + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);

		if(answerSent){
			g.setColor(0xff5555);
			offsetCounter+= (g.getFont().getHeight())*2;
			if((System.currentTimeMillis()%600)<200)
				g.drawString("Vote registered",15,15+offsetCounter + Constants.SCREEN_OFFSET,Graphics.BOTTOM|Graphics.LEFT);
			else  if((System.currentTimeMillis()%600)<400)
				g.drawString("Vote registered..",15,15+offsetCounter + Constants.SCREEN_OFFSET,Graphics.BOTTOM|Graphics.LEFT);
			else
				g.drawString("Vote registered....",15,15+offsetCounter + Constants.SCREEN_OFFSET,Graphics.BOTTOM|Graphics.LEFT);

		}  else {
			g.setColor(0x0000ff);
			offsetCounter+= (g.getFont().getHeight())*2;
			for(int i=1;i<(currentAlternatives.length+1);i++){
				if(!(currentAlternatives[i-1]==null)){
					g.drawString(i + ". " + currentAlternatives[i-1],5,offsetCounter + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
					offsetCounter += (g.getFont().getHeight());
				}
			}
		}
		flushGraphics();
	}



	/**
	 *
	 * Interprets keystrokes
	 *
	 * @param keyCode
	 */
	protected void keyPressed(int keyCode){
		try{   
			if (keyCode ==-11){
				cmdL.commandAction(new Command("EXIT",Command.SCREEN,1),this);
			}
			System.out.println("keycode" + keyCode);
			if((screenState == Constants.SCREENSTATE_QUESTION_POPPER) && (!answerSent)){
				if(keyCode==49){
					cmdL.commandAction(new Command("1",Command.SCREEN,1),this);
				} else if(keyCode==50) {
					cmdL.commandAction(new Command("2",Command.SCREEN,1),this);
				}  else if(keyCode==51) {
					cmdL.commandAction(new Command("3",Command.SCREEN,1),this);
				}   else if(keyCode==52) {
					cmdL.commandAction(new Command("4",Command.SCREEN,1),this);
				}   else if(keyCode==53) {
					//cmdL.commandAction(new Command("5",Command.SCREEN,1),this);
				}   else if(keyCode==54) {
					//cmdL.commandAction(new Command("6",Command.SCREEN,1),this);
				}
			} else if (readyToClose){
				cmdL.commandAction(new Command("EXIT",Command.SCREEN,1),this);
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}//

	/**
	 *
	 * Draw the temporary result after a question is answered.
	 *
	 * @param g
	 */
	public void drawResults(Graphics g){
		if((System.currentTimeMillis()-resultTimer)<3500){
			if(timesUp){
				g.setColor(0x00008b);
				g.drawString("Sorry mate!",5,0 + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
				g.setColor(0xff2222);
				g.drawString("TIME US UP!",5,30 + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT );
			}

			else if(lastResults.equals("")){
				g.setColor(0x00008b);
				if(currentAnswerWasCorrect){
					g.drawString("WELL DONE!",5,0+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
				} else {
					g.drawString("Wrong answer, buddy!",5,+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
				}
				g.setColor(0x5f9ea0);
				g.drawString("Current score is " + currentScore + " points",5,30+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT );
				g.drawString("out of " + currentMaxScore + " possible.",5,g.getFont().getHeight() + 32 + Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT );

			} else {
				g.setColor(0x00008b);
				g.drawString("FINAL SCORE",5,0+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT);
				g.setColor(0x5f9ea0);
				g.drawString(lastResults,5,30+ Constants.SCREEN_OFFSET,Graphics.TOP|Graphics.LEFT );
			}
		}else {
			///clientNetwork.wakeMe(); // why need this, tientl?
			resultTimer = 0;
			screenState = Constants.SCREENSTATE_IDLE;
		}
	}

	/**
	 * Update the current screen state according to the logical flow in the program.
	 *
	 * @param i The constant describing the state.
	 */
	public void updateScreenState(int i){
		screenState = i;
	}

	/**
	 * Flag telling the graphical rendering that the answer has been sent.
	 */
	public void answerSent() {
		answerSent = true;
	}

	/**
	 *
	 * Updates the logical representation of the current score before displaying it to the user.
	 *
	 * @param isCorrect
	 * @param currentScore
	 * @param maxScore
	 */
	public void updateReslts(boolean isCorrect,java.lang.String currentScore, java.lang.String maxScore) {
		currentAnswerWasCorrect = isCorrect;
		this.currentScore = currentScore;
		this.currentMaxScore = maxScore;
		resultTimer = System.currentTimeMillis();
	}

	/**
	 * Updates the logical representation of the end score before displaying it to the user.
	 *
	 * @param s
	 * @param m
	 */
	public void updateLastResults(String s, String m) {
		lastResults = s;
		currentMaxScore = m;

	}

	/**
	 * Flags the program as ready to close after the user has seen his final score.
	 * This flags triggers a message on screen and listening for the user to exit by pressing a key.
	 *
	 */
	public void readyToClose(){
		readyToClose = true;
	}

	/**
	 * Triggered from a timertask when the time is up to display the appropriate graphics.
	 *
	 */
	public void timesUp() {
		timesUp = true;
		resultTimer = System.currentTimeMillis();
		updateScreenState(Constants.SCREENSTATE_RESULTS);
		currentAnswerWasCorrect = false;
		//clientNetwork.wakeMe();
		System.out.println("Timesup kjrt");
	}

	/**
	 * Reset the times up flag after usage.
	 */
	public void resetTimesUp(){
		timesUp = false;
	}

	/**
	 * Makes a member reference to the network Thread.
	 *
	 * @param clientNetwork
	 */
//	public void setNetwork(MessagesExchangeThread clientNetwork) {
//	this.clientNetwork = clientNetwork;
//	}
}


