package GameEngine.Core;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Extend the GameCommunicator to handle the communication between the GE and mobile client
 * is responsible to receive message from mobile client
 * @author tranlongtien
 *
 */
public class MobileCommunicator extends GameCommunicator {

	String username;
    String password;
    String lectureCode;
    
    private int answerIndex;
    private int currentScore;
    private int maxScore;

	/**
	 * @throws IOException 
	 */
	protected MobileCommunicator(Socket soc, Game game) throws IOException{

		super(soc,game);
		// TODO Auto-generated constructor stub
		
	}//
	
	public void setUserName(String user){
		username =user;		
	}
	
	public String getUserName(){
		return username;
	}
	
	public void setPassword(String pass){
		password = pass;		
	}
	
	public void setLectureCode(String lecCode){
		lectureCode = lecCode;		
	}
	
	/** 
	 * Override the parrent method
	 * The receiver thread run to response to request from master client
	 * Will be called (run forever )until return false
	 */
	public boolean onReceive(){
		
		try {
			// receive message
			strMessageIn = in.readLine();		
			//System.out.println("From mobile client: " + strMessageIn);
		} catch (Exception e) {
			System.out.println("Err of getting request from MobileCli: !" + e.getMessage());
			e.printStackTrace();
			// Kill mobile server			
			this.closeConnection();
			return false;
		}				
		try{
			msg= new Message(strMessageIn);
			if (msg.getTypeOfMsg() == Message.MSG_EXIT)
			{
				this.closeConnection();
				return false;
			}
			// response to request
			myGame.processMobileMessage(msg, this);					
		}
		catch (Exception e) {}
		return true;
	}// end onReceive
	
	public void updateResutl(){
		answerIndex = -1;
		maxScore++;
	}//
	
	public void updateResult(boolean isCoorect, int index){
		if (isCoorect){ 
			currentScore ++;			
		}	
		answerIndex = index; 
	}//
	
	public void resetResult(){
		currentScore = 0;
		maxScore = 0;
		answerIndex = -1;
	}
	
	public int getAnswer(){
		return answerIndex;
	}
	
	public int getTotalScore(){
		return currentScore;
	}
	
	public int getMaxScore(){
		return maxScore;
	}
}
