package GameEngine.Core;


import GameEngine.DataBase.DataBaseConnection;


public class Round {

	private int[] roundList; // hold a list of rounds on the lecture
	private int roundIndex; // current round index

	private Question[] questionList; // hold all the questions on the round
	private int questionIndex;

	private DataBaseConnection db;
	
	/**
	 */
	public Question getNextQuestion(){
		if (isLastQuestion())
			return null;
		else
			return questionList[questionIndex++];
	}


	/**
	 */
	public boolean nextRound(){
		if (roundIndex < roundList.length -1){
			roundIndex++;
			questionList = db.getQuestion(roundList[roundIndex]);
			return true;
		}			
		else
			return false;
	}

	/**
	 * Sets tje lecture id where the rounds are to be extracted from
	 *
	 * @param lectureID the lectureID to be used
	 */
	public void getRoundsForLecture(int lectureID) {
		roundList = db.getRoundsInLecture(lectureID);		
	}


	/**
	 */
	public boolean isLastRound(){
		return (roundIndex == roundList.length);
	}

	public boolean isLastQuestion()
	{
		boolean ret = (questionIndex == questionList.length);
		return ret;
	}



	/**
	 */
	public Round(int lectureID){
		questionIndex = 0;
		roundIndex =0;
		db= new DataBaseConnection();
		getRoundsForLecture(lectureID);
		questionList = db.getQuestion(roundList[roundIndex]);			
	}

}
