import com.sun.midp.io.Util;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.*;
import java.util.Timer;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: ofsdahl
 * Date: 10.jan.2007
 * Time: 15:30:11
 * To change this template use File | Settings | File Templates.
 */
public class LeGaMidlet extends MIDlet implements CommandListener {

    protected MessagesExchangeThread clientNetwork;
    protected Thread networkThread;
    protected Command okCommand;
    protected boolean connectionOK;
    protected TextField input;
    protected Form inputForm;
    protected Form questionForm;
    protected Form messageFrm;
    public int inputState = Constants.BEGIN_PROGRAM;
    //protected Form okForm;
    protected LeGaGameCanvas okForm;
    protected int answerIndex = -1;
    protected Thread okThread;
    protected String nickName = "";
    protected String passWord = "";
    protected String lectureCode = "";
    protected long deleteMe = 0;
    private boolean readyToClose = false;
    private boolean CommandCreated_Retry = false;
    private boolean CommandCreated_NewUser = false;


    public LeGaMidlet() {
        //okForm = new Form("The Lecture Game");

        okForm = new LeGaGameCanvas(false);
        okForm.setCommandListener(this);
        okThread = new Thread(okForm);
        connectionOK = true;
        okCommand = new Command("OK", Command.OK, 1);
        messageFrm = new Form("Hey!");
    }

    protected void startApp() throws MIDletStateChangeException {

        try{
            //start network connection in separate thread
            clientNetwork = new MessagesExchangeThread(this);
            networkThread = new Thread(clientNetwork);
            networkThread.start();
            forcedLogin();
            //keepAlive = new KeepAliveThread();
            //keepAlive.init(clientNetwork);
           // new Thread(keepAlive).start();
        } catch(Exception e){
            e.printStackTrace();
        }

        okForm.setNetwork(clientNetwork);
        //prompt lecture code
    }

    protected void forcedLogin() {
        inputForm = new Form("");
        input = new TextField("Write your desired or registered nickname....", "", 14, TextField.INITIAL_CAPS_WORD);
        input.setConstraints(TextField.NON_PREDICTIVE);
        inputForm.setCommandListener(this);
        inputForm.addCommand(okCommand);
        inputForm.append(input);
        Display.getDisplay(this).setCurrent(inputForm);
        inputState = Constants.ENTER_PASSWORD;
    }

    protected void pauseApp() {

    }

    protected void destroyApp(boolean b) throws MIDletStateChangeException {
        try {
            clientNetwork.close();
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        //System.exit(0);
        notifyDestroyed();
    }


    public void commandAction(Command command, Displayable displayable) {
        try{
           if(readyToClose){
                 System.out.println();
                 destroyApp(true);
            }
            if(inputState!=Constants.QUESTION_POSED){
                if (command.getLabel().equals("OK")) {
                    if (inputState == (-1)){
                             messageFrm.append("We're just wating for the Internet.. Hang on..");
                            Display.getDisplay(this).setCurrent(messageFrm);
                            inputState = Constants.WAITING_FOR_CONNECTION;
                        return;
                    }
                    else if (inputState == Constants.BEGIN_PROGRAM) {
                        input = new TextField("What's your nickname?", "", 14, TextField.INITIAL_CAPS_WORD);
                        input.setConstraints(TextField.NON_PREDICTIVE);
                        inputForm.setCommandListener(this);
                        inputForm.addCommand(okCommand);
                        Display.getDisplay(this).setCurrent(inputForm);
                    } else if (inputState == Constants.ENTER_PASSWORD) {
                        nickName = input.getString();
                        input.setLabel("Enter password...");
                        input.setString("");
                        input.setConstraints(TextField.PASSWORD);
                        inputState = Constants.ENTER_LECTURE_CODE;

                        Display.getDisplay(this).setCurrent(inputForm);

                    } else if (inputState == Constants.ENTER_LECTURE_CODE) {
                        passWord = input.getString();
                        input.setLabel("Please enter the lecture code displayed on the lecture screen");
                        input.setString("");
                        input.setConstraints(TextField.NON_PREDICTIVE);
                        inputState = Constants.READY_FOR_LOGIN;
                        Display.getDisplay(this).setCurrent(inputForm);
                    } else if (inputState == Constants.READY_FOR_LOGIN) {
                        lectureCode = input.getString();
                        if(!connectionOK) {
                            messageFrm.append("We're just wating for the Internet.. Hang on..");
                            Display.getDisplay(this).setCurrent(messageFrm);
                            inputState = Constants.WAITING_FOR_CONNECTION;

                        } else {
                            clientNetwork.send("@^LGN" + nickName + "|" + passWord + "|" + lectureCode + "^@");
                            waitIDLE();
                        }
                    }

                }
                else if (command.getLabel().equals("New User")) {
                    if (inputState == Constants.USER_NOT_FOUND) {
                        clientNetwork.send("@^REG" + nickName + "|" + passWord + "|" + lectureCode + "^@");
                        Display.getDisplay(this).setCurrent(okForm);
                        waitIDLE();
                    }
                }
                else if (command.getLabel().equals("Retry")) {
                    inputState = Constants.BEGIN_PROGRAM;
                    forcedLogin();
                }
            } else {
                Display.getDisplay(this).vibrate(260);
                answerIndex = Integer.parseInt(command.getLabel()) - 1;
                clientNetwork.send("@^ANS" + answerIndex + "^@");
                inputState = Constants.QUESTION_ANSWERED;
                okForm.answerSent();
                clientNetwork.wakeMe();
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    }//



    public void networkFailure() {
        if (inputState != (-1)) {
            inputState = -1;
            messageFrm.append("Sorry.. Couldn't get a network connection. Restarting the application later might work..");
            Display.getDisplay(this).setCurrent(messageFrm);
        }
    }

    public void parse(String received) {
        Display.getDisplay(this).flashBacklight(10);
        int numberOfFields = 0;
        String[] stringList = new String[Constants.MAX_NUMBER_OF_FIELDS_IN_MSG];
        String code = received.substring(0, 3);
        received = received.substring(3, received.length());
        while (numberOfFields < Constants.MAX_NUMBER_OF_FIELDS_IN_MSG) {
            int msgLength = received.indexOf("|");
            if (msgLength == (-1)) {
                stringList[numberOfFields] = received.substring(0, received.length());
                numberOfFields++;
                break;
            } else {
                stringList[numberOfFields] = received.substring(0, Math.abs(msgLength));
                received = received.substring(msgLength + 1, received.length());
                //System.err.println(received + " " + msgLength);
                numberOfFields++;
            }
        }
        //for (int k = 0; k < numberOfFields; k++) {
        //    System.err.println(stringList[k]);
        //}
        if(code.equals("PNG") ){
            if(deleteMe==0){
                deleteMe = System.currentTimeMillis();
            }
            long print = System.currentTimeMillis() - deleteMe;
            deleteMe = System.currentTimeMillis();
            clientNetwork.send("@^PNG"+ print+"^@");
            new Timer().schedule(new ScheduledTask(clientNetwork), (long) (100));




        }
       else if (code.equals("CRP")) {
                clientNetwork.send("T");
        }
        else if (code.equals("QST") && (inputState == Constants.LOGGED_IN)) {
            String question = stringList[0];
            int nbrOfAlternatives = Integer.parseInt(stringList[1]);
            int seconds = Integer.parseInt(stringList[nbrOfAlternatives + 2]);
            String[] alternatives = new String[nbrOfAlternatives];
            for (int i = 0; i < nbrOfAlternatives; i++) {
                alternatives[i] = stringList[i + 2];
            }
            okForm.setCurrentAlternatives(alternatives);
            okForm.setCurrentQuestion(question);
            okForm.updateScreenState(Constants.SCREENSTATE_QUESTION_POPPER);
            inputState = Constants.QUESTION_POSED;
            //Display.getDisplay(this).setCurrent(questionForm);
            new Timer().schedule(new ScheduledTask(this), (long) (seconds * 1000));

        } else if (code.equals("LGN")) {
            System.err.println(stringList[0]);
            if (stringList[0].equals("OK")) {
                Alert al = new Alert("Sucess!", "Welcome! Let the games begin.. Submit answers by pressing the number buttons on your phone.", null, AlertType.INFO);
                al.setTimeout(Constants.STD_HOLD_SCREEN_MILLISECONDS);
                okForm.updateScreenState(Constants.SCREENSTATE_IDLE);
                okThread.start();
                Display.getDisplay(this).setCurrent(al,okForm);
                inputState = Constants.LOGGED_IN;


            } else if (stringList[0].equals("UNKNOWN")) {
                messageFrm.deleteAll();
                if(!CommandCreated_NewUser){
                messageFrm.addCommand(new Command("New User", Command.SCREEN, 2));
                CommandCreated_NewUser = true;
                }
                if(!CommandCreated_Retry){
                    messageFrm.addCommand(new Command("Retry", Command.SCREEN, 1));
                    CommandCreated_Retry = true;
                }
                messageFrm.append("No one we know! Is this a new user, or would you like to retry logging in?");
                messageFrm.setCommandListener(this);
                Display.getDisplay(this).setCurrent(messageFrm);
                inputState = Constants.USER_NOT_FOUND;
            } else if(stringList[0].equals("NO")){
                messageFrm.deleteAll();
                if(!CommandCreated_Retry) {
                    messageFrm.addCommand(new Command("Retry", Command.SCREEN, 1));
                    CommandCreated_Retry = true;
                }
                messageFrm.append("The user exists already or data was missing. Please try again..");
                messageFrm.setCommandListener(this);
                Display.getDisplay(this).setCurrent(messageFrm);
                inputState = Constants.FAILED_LOGIN;
            }

        } else if (code.equals("RES")) {
            boolean isCorrect = true;
            if (answerIndex != Integer.parseInt(stringList[0])) {
                Display.getDisplay(this).vibrate(1000);
                isCorrect = false;
            } else {
                Display.getDisplay(this).flashBacklight(1000);
            }
            okForm.updateReslts(isCorrect,stringList[1],(stringList[2]));
            okForm.updateScreenState(Constants.SCREENSTATE_RESULTS);
            inputState = Constants.LOGGED_IN;
        } else if (code.equals("DIE")) {
            okForm.updateLastResults(stringList[0],stringList[1]);
            okForm.updateScreenState(Constants.SCREENSTATE_ENDGAME);
            new Timer().schedule(new CloseScheduledTask(okForm, this), (long) (4000));
            

        }
        clientNetwork.received = null;
        System.out.println("Ferdig i parsemetoden");
    }

    private void waitIDLE() {
        System.err.println("waitIdle kj�res");
        Display.getDisplay(this).setCurrent(okForm);
        if (!(clientNetwork.received == null)) {
            parse(clientNetwork.received);
        }

        clientNetwork.wakeMe();
        System.err.println("GUItr�d kj�rt ferdig2");

    }

    public void networkStatus(boolean connectionOK) {
        this.connectionOK = connectionOK;
        if (inputState == Constants.WAITING_FOR_CONNECTION && connectionOK) {

        } else if (!connectionOK) {
            networkFailure();
        }
    }

    public void timesUp() {
        if (inputState == Constants.QUESTION_POSED) {
            okForm.timesUp();
            inputState = Constants.LOGGED_IN;
            //clientNetwork.wakeMe();
        }

    }

    public void readyToClose() {
        readyToClose = true;
    }

}


