import com.sun.midp.io.Util;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.microedition.lcdui.*;

import java.util.Timer;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: ofsdahl
 * Date: 10.jan.2007
 * Time: 15:30:11
 * Updated by Tien, 26 April 2008
 * To change this template use File | Settings | File Templates.
 */
public class LeGaMidlet extends MIDlet implements CommandListener {

	protected MessagesExchangeThread mobileClient; // responsible to communicate with Game engine, using socket.
	protected Thread receiveThread;
	
	private Question currentQues;

	protected Command okCmd;
	protected Command exitCmd;
	protected TextField input;
	
	protected Form inputForm; // Form to collect input from user 
	
	protected Form messageFrm; // For display message
	/**
	 * the state of game will change during the game
	 * The game will really start when the gameState set to LOGGED_IN
	 * The state from 0-4 (BEGIN_PROGRAM, ENTER_NICKNAME, ENTER_PASSWORD, ENTER_LECTURECODE) is for collect
	 * input data
	 * The others state is for playing game.
	 */
	public int gameState = Constants.BEGIN_PROGRAM;

	protected LeGaGameCanvas gameBoard; // Responsible for graphics
	protected int answerIndex = -1;
	protected Thread gameBoardThread;

	//input from user
	protected String nickName = "";
	protected String passWord = "";
	protected String lectureCode = "";

	protected long deleteMe = 0;
	private boolean readyToClose = false;
	//private boolean CommandCreated_Retry = false;
	//private boolean CommandCreated_NewUser = false;
	protected boolean connectionOK;


	/**
	 * Constructor
	 * 
	 */
	public LeGaMidlet() {
		gameBoard = new LeGaGameCanvas(false);
		gameBoard.setCommandListener(this);
		// Thread responsible for update graphics of game
		gameBoardThread = new Thread(gameBoard);
		
		connectionOK = true;
		okCmd = new Command("OK", Command.OK, 1);
		exitCmd = new Command("Exit", Command.EXIT,2);
		messageFrm = new Form("Hey!");
		inputForm = new Form("");
	}

	/*
	 * implementation of MIDlet
	 */

	protected void startApp() throws MIDletStateChangeException {

		try{
			//start network connection in separate thread
			mobileClient = new MessagesExchangeThread(this);
			receiveThread = new Thread(mobileClient);
			
			forcedLogin(); //The first screen to display, asking for nickname.
			//keepAlive = new KeepAliveThread();
			//keepAlive.init(mobileClient);
			// new Thread(keepAlive).start();
		} catch(Exception e){
			e.printStackTrace();
		}
		// gameBoard.setNetwork(mobileClient); //why need this ??? tientl
	}//
	
	/**
	 * start the thread to receive message from game engine
	 *
	 */
	private void startReceive(){
		// thread getting msg from GE, the msg will be process in onReceive funciton
		receiveThread.start(); 
	}//

	/**
	 * The first screen to display is the input form, asking for nickname of user
	 *
	 */
	protected void forcedLogin() {
		//inputForm = new Form("");
		input = new TextField("Write your desired or registered nickname....", "", 14, TextField.INITIAL_CAPS_WORD);
		System.out.println("char per line: " + input.getMaxSize());
		input.setConstraints(TextField.NON_PREDICTIVE);
		inputForm.setCommandListener(this);
		inputForm.addCommand(okCmd);
		inputForm.addCommand(exitCmd);
		inputForm.append(input);
		Display.getDisplay(this).setCurrent(inputForm);
		gameState = Constants.ENTER_NICKNAME;
	}

	protected void pauseApp() {

	}

	protected void destroyApp(boolean b) throws MIDletStateChangeException {
		try {
			mobileClient.close();
		} catch (IOException e) {
			e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
		}
		notifyDestroyed();
	}


	/**
	 * implementation of CommandListener interface
	 */
	public void commandAction(Command command, Displayable displayable) {

		try{
			if(readyToClose || command ==exitCmd || command.getLabel().equalsIgnoreCase("exit")){
				System.out.println();
				destroyApp(true);
				notifyDestroyed();
			}
			if(gameState!=Constants.QUESTION_POSED){
				if (command == okCmd){
					if (gameState == Constants.BEGIN_PROGRAM) {
						input = new TextField("What's your nickname?", "", 14, TextField.INITIAL_CAPS_WORD);
						input.setConstraints(TextField.NON_PREDICTIVE);
						inputForm.setCommandListener(this);
						inputForm.addCommand(okCmd);
						inputForm.addCommand(exitCmd);
						Display.getDisplay(this).setCurrent(inputForm);
					} else if (gameState == Constants.ENTER_NICKNAME) { // if click ok when state is enter nickname
						nickName = input.getString();
						input.setLabel("Enter password...");
						input.setString("");
						input.setConstraints(TextField.PASSWORD);
						gameState = Constants.ENTER_PASSWORD;

						Display.getDisplay(this).setCurrent(inputForm);

					} else if (gameState == Constants.ENTER_PASSWORD) {
						passWord = input.getString();
						input.setLabel("Please enter the lecture code displayed on the lecture screen");
						input.setString("");
						input.setConstraints(TextField.NON_PREDICTIVE);
						if(connectionOK) { // if network is ok and have all information :)							
							mobileClient.send(nickName);
							mobileClient.send(passWord);
						} else {
							messageFrm.append("We're just wating for the Internet.. Hang on..");
							Display.getDisplay(this).setCurrent(messageFrm);
							gameState = Constants.WAITING_FOR_CONNECTION;
						}
						gameState = Constants.ENTER_LECTURE_CODE;
						Display.getDisplay(this).setCurrent(inputForm);
					} else if (gameState == Constants.ENTER_LECTURE_CODE){ 
						// will try to get the lecture code from user
						lectureCode = input.getString();
						if(connectionOK) { // if network is ok then send the lecture code						
							mobileClient.send(lectureCode);
						} 
						Message msg = mobileClient.receiveMsg(); // GE will check the code and send back result
						if(msg.msgType == Message.MSG_LECTURE_ID){ // if the result is ok
							gameState= Constants.READY_FOR_LOGIN; // change game state to ready for play
							startReceive(); // start the receive process, the next expected msg from server say that "login ok"
						} else {
							input.setLabel("Try again! Enter the lecture code displayed on the lecture screen.");
							input.setString("");
							input.setConstraints(TextField.NON_PREDICTIVE);
//							Display.getDisplay(this).setCurrent(inputForm);
						}							
					}// end to collect lectureCode 
				}
			} else //(gameState==Constants.QUESTION_POSED) 
			{ // try to send the answer of user
				Display.getDisplay(this).vibrate(260);
				answerIndex = Integer.parseInt(command.getLabel()) - 1;
				mobileClient.send(""+ Message.MSG_ANSWER + answerIndex);
				//System.out.println("ans " + Message.MSG_ANSWER + answerIndex + "");
				gameState = Constants.QUESTION_ANSWERED;
				gameBoard.answerSent();
				//mobileClient.wakeMe(); ?? tientl
			}
		}catch(Exception e){
			e.printStackTrace();
		}

	}//

	private void displayGameboard() {
		Display.getDisplay(this).setCurrent(gameBoard);
		//mobileClient.wakeMe(); //tientl why???
	}//


	public void networkFailure() {
		if (gameState != (-1)) {
			gameState = -1;
			messageFrm.append("Sorry.. Couldn't get a network connection. Restarting the application later might work..");
			Display.getDisplay(this).setCurrent(messageFrm);
		}
	}

	/***
	 * Parses the input strings and calls the appropriate method with appopriate in/out.
	 * Called by the receiver thread when the message arrived from game engine
	 * @param msg: message from GE
	 */
/*	   public void parse(String received) {
	        Display.getDisplay(this).flashBacklight(10);
	        int numberOfFields = 0;
	        String[] stringList = new String[Constants.MAX_NUMBER_OF_FIELDS_IN_MSG];
	        String code = received.substring(0, 3);
	        received = received.substring(3, received.length());
	        while (numberOfFields < Constants.MAX_NUMBER_OF_FIELDS_IN_MSG) {
	            int msgLength = received.indexOf("|");
	            if (msgLength == (-1)) {
	                stringList[numberOfFields] = received.substring(0, received.length());
	                numberOfFields++;
	                break;
	            } else {
	                stringList[numberOfFields] = received.substring(0, Math.abs(msgLength));
	                received = received.substring(msgLength + 1, received.length());
	                //System.err.println(received + " " + msgLength);
	                numberOfFields++;
	            }
	        }
	        //for (int k = 0; k < numberOfFields; k++) {
	        //    System.err.println(stringList[k]);
	        //}
	        if(code.equals("PNG") ){
	            if(deleteMe==0){
	                deleteMe = System.currentTimeMillis();
	            }
	            long print = System.currentTimeMillis() - deleteMe;
	            deleteMe = System.currentTimeMillis();
	            clientNetwork.send("@^PNG"+ print+"^@");
	            new Timer().schedule(new ScheduledTask(clientNetwork), (long) (100));




	        }
	       else if (code.equals("CRP")) {
	                clientNetwork.send("T");
	        }
	        else if (code.equals("QST") && (inputState == Constants.LOGGED_IN)) {
	            String question = stringList[0];
	            int nbrOfAlternatives = Integer.parseInt(stringList[1]);
	            int seconds = Integer.parseInt(stringList[nbrOfAlternatives + 2]);
	            String[] alternatives = new String[nbrOfAlternatives];
	            for (int i = 0; i < nbrOfAlternatives; i++) {
	                alternatives[i] = stringList[i + 2];
	            }
	            okForm.setCurrentAlternatives(alternatives);
	            okForm.setCurrentQuestion(question);
	            okForm.updateScreenState(Constants.SCREENSTATE_QUESTION_POPPER);
	            inputState = Constants.QUESTION_POSED;
	            //Display.getDisplay(this).setCurrent(questionForm);
	            new Timer().schedule(new ScheduledTask(this), (long) (seconds * 1000));

	        } else if (code.equals("LGN")) {
	            System.err.println(stringList[0]);
	            if (stringList[0].equals("OK")) {
	                Alert al = new Alert("Sucess!", "Welcome! Let the games begin.. Submit answers by pressing the number buttons on your phone.", null, AlertType.INFO);
	                al.setTimeout(Constants.STD_HOLD_SCREEN_MILLISECONDS);
	                okForm.updateScreenState(Constants.SCREENSTATE_IDLE);
	                okThread.start();
	                Display.getDisplay(this).setCurrent(al,okForm);
	                inputState = Constants.LOGGED_IN;


	            } else if (stringList[0].equals("UNKNOWN")) {
	                messageFrm.deleteAll();
	                if(!CommandCreated_NewUser){
	                messageFrm.addCommand(new Command("New User", Command.SCREEN, 2));
	                CommandCreated_NewUser = true;
	                }
	                if(!CommandCreated_Retry){
	                    messageFrm.addCommand(new Command("Retry", Command.SCREEN, 1));
	                    CommandCreated_Retry = true;
	                }
	                messageFrm.append("No one we know! Is this a new user, or would you like to retry logging in?");
	                messageFrm.setCommandListener(this);
	                Display.getDisplay(this).setCurrent(messageFrm);
	                inputState = Constants.USER_NOT_FOUND;
	            } else if(stringList[0].equals("NO")){
	                messageFrm.deleteAll();
	                if(!CommandCreated_Retry) {
	                    messageFrm.addCommand(new Command("Retry", Command.SCREEN, 1));
	                    CommandCreated_Retry = true;
	                }
	                messageFrm.append("The user exists already or data was missing. Please try again..");
	                messageFrm.setCommandListener(this);
	                Display.getDisplay(this).setCurrent(messageFrm);
	                inputState = Constants.FAILED_LOGIN;
	            }

	        } else if (code.equals("RES")) {
	            boolean isCorrect = true;
	            if (answerIndex != Integer.parseInt(stringList[0])) {
	                Display.getDisplay(this).vibrate(1000);
	                isCorrect = false;
	            } else {
	                Display.getDisplay(this).flashBacklight(1000);
	            }
	            okForm.updateReslts(isCorrect,stringList[1],(stringList[2]));
	            okForm.updateScreenState(Constants.SCREENSTATE_RESULTS);
	            inputState = Constants.LOGGED_IN;
	        } else if (code.equals("DIE")) {
	            okForm.updateLastResults(stringList[0],stringList[1]);
	            okForm.updateScreenState(Constants.SCREENSTATE_ENDGAME);
	            new Timer().schedule(new CloseScheduledTask(okForm, this), (long) (4000));	            
	        }
	        clientNetwork.received = null;
	        System.out.println("Ferdig i parsemetoden");
	    }*/
	
	public void onReceive(Message msg) {
		Display.getDisplay(this).flashBacklight(10);
		msg.printMsg();

		if (msg.isLoggedIn()){
			Alert al = new Alert("Sucess!", "Welcome! Let the games begin.. Submit answers by pressing the number buttons on your phone.", null, AlertType.INFO);
			al.setTimeout(Constants.STD_HOLD_SCREEN_MILLISECONDS);
			gameBoard.updateScreenState(Constants.SCREENSTATE_IDLE);
			gameState = Constants.LOGGED_IN;
			// start the thread to draw the graphics of game
			gameBoardThread.start();
			Display.getDisplay(this).setCurrent(al,gameBoard);			
		} else if (msg.isQuestion()){
			if (gameState == Constants.LOGGED_IN){
				// update data to display
				currentQues = msg.buildQuestion();
				currentQues.printQuestion(); //For debug
				int seconds = currentQues.getTimeLimit();
				
				gameBoard.setCurrentAlternatives(currentQues.getAlternatives());
				gameBoard.setCurrentQuestion(currentQues.getQuestion());
				// update screen state so that the graphics thread can update screen
				gameBoard.updateScreenState(Constants.SCREENSTATE_QUESTION_POPPER);
				// say that question has posted
				gameState = Constants.QUESTION_POSED;				
				new Timer().schedule(new ScheduledTask(this), (long) (seconds * 1000));			
			}
		} else if (msg.isAnswer()){//(code.equals("RES")) {
            boolean isCorrect = true;
            if (answerIndex != currentQues.getCorrectAlternative()) {
                Display.getDisplay(this).vibrate(1000);
                isCorrect = false;
            } else {
                Display.getDisplay(this).flashBacklight(1000);
            }
            gameBoard.updateReslts(isCorrect,Integer.toString(msg.getTotalScore()),Integer.toString(msg.getMaxScore()));
            //System.out.println ("answer is: " + Integer.toString(msg.getTotalScore()) + "," +Integer.toString(msg.getMaxScore())) ;
            gameBoard.updateScreenState(Constants.SCREENSTATE_RESULTS);
            gameState = Constants.LOGGED_IN;
        } else if (msg.isEndOfGame()){
            gameBoard.updateLastResults(Integer.toString(msg.getTotalScore()),Integer.toString(msg.getMaxScore()));
            gameBoard.updateScreenState(Constants.SCREENSTATE_ENDGAME);
            new Timer().schedule(new CloseScheduledTask(gameBoard, this), (long) (4000));            
        }     
	}//


	public void networkStatus(boolean connectionOK) {
		this.connectionOK = connectionOK;
		if (gameState == Constants.WAITING_FOR_CONNECTION && connectionOK) {

		} else if (!connectionOK) {
			networkFailure();
		}
	}

	public void timesUp() {
		if (gameState == Constants.QUESTION_POSED) {
			gameBoard.timesUp();
			gameState = Constants.LOGGED_IN;
			//mobileClient.wakeMe();
		}

	}

	public void readyToClose() {
		readyToClose = true;
	}

}// End class


