
/**
 * Created by IntelliJ IDEA.
 * User: olekrst
 * Date: 26.jan.2007
 * Time: 16:40:05
 * Modifyed by tien 10.4.2008
 * This class is a generalization of a question, as used in the LectureGame.Core.LG
 */
public class Question {

    /** 
	 * @uml.property name="question"
	 */
    private String question = "";
    /** 
	 * @uml.property name="numberOfAlt"
	 */
    private int numberOfAlt;
    /**
	 * @uml.property  name="alternatives" multiplicity="(0 -1)" dimension="1"
	 */
    private String[] alternatives;
    /** 
	 * @uml.property name="timeLimit"
	 */
    private String timeLimit = "";
    /** 
	 * @uml.property name="correctAlternative"
	 */
    private int correctAlternative = -1; // index of correct answer
    private String formattedQuestion;

    /**
     * @param question Question text. example "who am i?"
     * @param numberOfAlt number of answers to choose from
     * @param alternatives Array of alternatives. example {"me","you","them"}
     * @param timeLimit time given to reply to the question. 0 = the server decides
     * @param correctAlternative index number of the alternative in the Array of alternatives that is correct. Can only be one
     */
    public Question(String question, int numberOfAlt, String[] alternatives, String timeLimit, int correctAlternative) {

        this.question = question;
        this.numberOfAlt = numberOfAlt;
        this.alternatives = alternatives;
        this.timeLimit = timeLimit;
        this.correctAlternative = correctAlternative;
        this.formattedQuestion = null;
    }

    public Question() {
		// TODO Auto-generated constructor stub
	}

/*	*//**
     * Creates the root of the question to be sendt to eighter the studenclients or the masterclient. The
     * root is similar, thus this only needs one method. The last part of the question is different though.
     *
     * Example of output:
     *
     * @^QSTWho am I?|3|me|you|them|30|
     *
     * this is translated to
     * question: who am I?
     * number of alternatives: 3
     * alternative 1: me
     * alternative 2: you
     * alternative 3: them
     * timelimit: 30 s
     *
     * @return  a question root
     *//*
    private String makeQuestionRoot() {
        if (formattedQuestion != null) return formattedQuestion;
        formattedQuestion = "@^QST" + question + "|" + Integer.toString(numberOfAlt);
        for (String alternative : alternatives) formattedQuestion += "|" + alternative;
        return formattedQuestion += "|" + timeLimit +"|";
    }*/


    /**
     * This method is used for testing purposes. prints the question to console.
     */
    public void testQuestion() {
        System.out.println("sprsml: " + question);
        for (int i = 0; i < alternatives.length; i++) System.out.println("alt #" + i + ": " + alternatives[i]);
        System.out.println("   ***   ");
    }



    public String getformattedQuestion(){
    	return formattedQuestion;
    }

    /** 
	 * Returns the timelimit of the question
	 * @return  timelimit
	 * @uml.property  name="timeLimit"
	 */
    public int getTimeLimit() {
		return Integer.parseInt(timeLimit);
	}

	/**
	 * Getter of the property <tt>numberOfAlt</tt>
	 * @return  Returns the numberOfAlt.
	 * @uml.property  name="numberOfAlt"
	 */
	public int getNumberOfAlt() {
		return numberOfAlt;
	}

	/**
	 * Setter of the property <tt>numberOfAlt</tt>
	 * @param numberOfAlt  The numberOfAlt to set.
	 * @uml.property  name="numberOfAlt"
	 */
	public void setNumberOfAlt(int numberOfAlt) {
		this.numberOfAlt = numberOfAlt;
	}

	/**
	 * Getter of the property <tt>question</tt>
	 * @return  Returns the question.
	 * @uml.property  name="question"
	 */
	public String getQuestion() {
		return question;
	}

	/**
	 * Setter of the property <tt>question</tt>
	 * @param question  The question to set.
	 * @uml.property  name="question"
	 */
	public void setQuestion(String question) {
		this.question = question;
	}

	/**
	 * Setter of the property <tt>timeLimit</tt>
	 * @param timeLimit  The timeLimit to set.
	 * @uml.property  name="timeLimit"
	 */
	public void setTimeLimit(String timeLimit) {
		this.timeLimit = timeLimit;
	}

	/**
	 * Getter of the property <tt>correctAlternative</tt>
	 * @return  Returns the correctAlternative.
	 * @uml.property  name="correctAlternative"
	 */
	public int getCorrectAlternative() {
		return correctAlternative;
	}

	/**
	 * Setter of the property <tt>correctAlternative</tt>
	 * @param correctAlternative  The correctAlternative to set.
	 * @uml.property  name="correctAlternative"
	 */
	public void setCorrectAlternative(int correctAlternative) {
		this.correctAlternative = correctAlternative;
	}

	/**
	 * Getter of the property <tt>alternatives</tt>
	 * @return  Returns the alternatives.
	 * @uml.property  name="alternatives"
	 */
	public String[] getAlternatives() {
		return alternatives;
	}

	/**
	 * Setter of the property <tt>alternatives</tt>
	 * @param alternatives  The alternatives to set.
	 * @uml.property  name="alternatives"
	 */
	public void setAlternatives(String[] alternatives) {
		this.alternatives = alternatives;
	}
	
	public void printQuestion()
	{
		System.out.println(getQuestion());
		System.out.println("-" + getNumberOfAlt());
		System.out.println("- " + alternatives[0]);
		System.out.println("-" + alternatives[1]);
		System.out.println("-" + alternatives[2]);
		System.out.println("-" + alternatives[3]);
		System.out.println("> correct: " + getCorrectAlternative());
	}
}
